Page MenuHome

blender 2.8 exports fbx to unity 2018.3. The rendering mode of Material is "Transparent". It depends of the color of the 3D object
Closed, ResolvedPublic

Description

System Information
windows 10 pro version 1803
nvidia gtx 1080

Blender Version
Version 2.80 Beta
2018-12-24
6d89337257b6

Short description of error
Create a new project (File > new > general)

Select the default cube on the scene and export it in fbx (File > export > FBX(.fbx))
Export FBX > Selected Objects

save it in directory "Assets" of a new unity project
In unity 3D, the cube is well exported but the rendering mode in unity 3D of the material shader is Transparent

Return in blender 3D and change the Base Color of the material that is white (R:0.8 G:0.8 B:0.8 A:1) to yellow (R:1 G:1 B:0.0 A:1)
repeat export and replace in unity the new file.

In unity 3D, the new cube is well exported but the rendering mode of the material shader is Opaque now

It is not a problem of geometry but a problem of color.
Thanks a lot

Details

Type
Bug

Event Timeline

Bastien Montagne (mont29) triaged this task as Needs Information from User priority.Feb 11 2019, 2:04 PM

Don’t know what to say here, there is no reason for that to happen. Did you try exporting two cubes in the same FBX, one with default, the other with yellow material?

Tired that here, and checked FBX material generated in the FBX file, they are identical, besides the different color values.

I have the same problem with 2 cubes (one red and the other grey) in the same file. The grey's one is transparent in Unity and the red one is opaque.
You can this post in the Unity forum.
blender 2.8 exports fbx to unity 2018.3. Rendering mode of Material is "Transparent". Color problem
I do not have this problem when I export with the glTF 2.0 format.
It is perhaps a Unity problem ?

I would think this is an issue on the importer… Here are material definitions for both (in same FBX file) (using our JSon extraction of FBX binary data):

["Material", [370385586, "Material::Material", ""], "LSS", [
    ["Version", [102], "I", []],
    ["ShadingModel", ["Phong"], "S", []],
    ["MultiLayer", [0], "I", []],
    ["Properties70", [], "", [
        ["P", ["DiffuseColor", "Color", "", "A", 0.800000011920929, 0.800000011920929, 0.800000011920929], "SSSSDDD", []],
        ["P", ["EmissiveColor", "Color", "", "A", 0.800000011920929, 0.800000011920929, 0.800000011920929], "SSSSDDD", []],
        ["P", ["EmissiveFactor", "Number", "", "A", 0.0], "SSSSD", []],
        ["P", ["AmbientColor", "Color", "", "A", 0.05087608844041824, 0.05087608844041824, 0.05087608844041824], "SSSSDDD", []],
        ["P", ["AmbientFactor", "Number", "", "A", 0.0], "SSSSD", []],
        ["P", ["TransparentColor", "Color", "", "A", 0.800000011920929, 0.800000011920929, 0.800000011920929], "SSSSDDD", []],
        ["P", ["SpecularColor", "Color", "", "A", 0.800000011920929, 0.800000011920929, 0.800000011920929], "SSSSDDD", []],
        ["P", ["SpecularFactor", "Number", "", "A", 0.25], "SSSSD", []],
        ["P", ["Shininess", "Number", "", "A", 25.0], "SSSSD", []],
        ["P", ["ShininessExponent", "Number", "", "A", 25.0], "SSSSD", []],
        ["P", ["ReflectionColor", "Color", "", "A", 0.800000011920929, 0.800000011920929, 0.800000011920929], "SSSSDDD", []],
        ["P", ["ReflectionFactor", "Number", "", "A", 0.0], "SSSSD", []]]]]],
["Material", [192667697, "Material.001::Material", ""], "LSS", [
    ["Version", [102], "I", []],
    ["ShadingModel", ["Phong"], "S", []],
    ["MultiLayer", [0], "I", []],
    ["Properties70", [], "", [
        ["P", ["DiffuseColor", "Color", "", "A", 1.0, 1.0, 0.0], "SSSSDDD", []],
        ["P", ["EmissiveColor", "Color", "", "A", 1.0, 1.0, 0.0], "SSSSDDD", []],
        ["P", ["EmissiveFactor", "Number", "", "A", 0.0], "SSSSD", []],
        ["P", ["AmbientColor", "Color", "", "A", 0.05087608844041824, 0.05087608844041824, 0.05087608844041824], "SSSSDDD", []],
        ["P", ["AmbientFactor", "Number", "", "A", 0.0], "SSSSD", []],
        ["P", ["TransparentColor", "Color", "", "A", 1.0, 1.0, 0.0], "SSSSDDD", []],
        ["P", ["SpecularColor", "Color", "", "A", 1.0, 1.0, 0.0], "SSSSDDD", []],
        ["P", ["SpecularFactor", "Number", "", "A", 0.25], "SSSSD", []],
        ["P", ["Shininess", "Number", "", "A", 25.0], "SSSSD", []],
        ["P", ["ShininessExponent", "Number", "", "A", 25.0], "SSSSD", []],
        ["P", ["ReflectionColor", "Color", "", "A", 1.0, 1.0, 0.0], "SSSSDDD", []],
        ["P", ["ReflectionFactor", "Number", "", "A", 0.0], "SSSSD", []]]]]]]],

You'll note that there are only color info here (RGB, without any alpha thingy).

And the 'common' part (aka template), which includes the 'alpha' value (well, values, since we have a TransparencyFactor and an Opacity - yep, usual FBX PoS):

["ObjectType", ["Material"], "S", [
    ["Count", [2], "I", []],
    ["PropertyTemplate", ["FbxSurfacePhong"], "S", [
        ["Properties70", [], "", [
            ["P", ["ShadingModel", "KString", "", "", "Phong"], "SSSSS", []],
            ["P", ["MultiLayer", "bool", "", "", 0], "SSSSI", []],
            ["P", ["EmissiveColor", "Color", "", "A", 0.0, 0.0, 0.0], "SSSSDDD", []],
            ["P", ["EmissiveFactor", "Number", "", "A", 1.0], "SSSSD", []],
            ["P", ["AmbientColor", "Color", "", "A", 0.2, 0.2, 0.2], "SSSSDDD", []],
            ["P", ["AmbientFactor", "Number", "", "A", 1.0], "SSSSD", []],
            ["P", ["DiffuseColor", "Color", "", "A", 0.8, 0.8, 0.8], "SSSSDDD", []],
            ["P", ["DiffuseFactor", "Number", "", "A", 1.0], "SSSSD", []],
            ["P", ["TransparentColor", "Color", "", "A", 0.0, 0.0, 0.0], "SSSSDDD", []],
            ["P", ["TransparencyFactor", "Number", "", "A", 0.0], "SSSSD", []],
            ["P", ["Opacity", "Number", "", "A", 1.0], "SSSSD", []],
            ["P", ["NormalMap", "Vector3D", "Vector", "", 0.0, 0.0, 0.0], "SSSSDDD", []],
            ["P", ["Bump", "Vector3D", "Vector", "", 0.0, 0.0, 0.0], "SSSSDDD", []],
            ["P", ["BumpFactor", "double", "Number", "", 1.0], "SSSSD", []],
            ["P", ["DisplacementColor", "ColorRGB", "Color", "", 0.0, 0.0, 0.0], "SSSSDDD", []],
            ["P", ["DisplacementFactor", "double", "Number", "", 1.0], "SSSSD", []],
            ["P", ["VectorDisplacementColor", "ColorRGB", "Color", "", 0.0, 0.0, 0.0], "SSSSDDD", []],
            ["P", ["VectorDisplacementFactor", "double", "Number", "", 1.0], "SSSSD", []],
            ["P", ["SpecularColor", "Color", "", "A", 0.2, 0.2, 0.2], "SSSSDDD", []],
            ["P", ["SpecularFactor", "Number", "", "A", 1.0], "SSSSD", []],
            ["P", ["Shininess", "Number", "", "A", 20.0], "SSSSD", []],
            ["P", ["ShininessExponent", "Number", "", "A", 20.0], "SSSSD", []],
            ["P", ["ReflectionColor", "Color", "", "A", 0.0, 0.0, 0.0], "SSSSDDD", []],
            ["P", ["ReflectionFactor", "Number", "", "A", 1.0], "SSSSD", []]]]]]]]]],

(template is a complete definition of a material, it features common values for all their propertie, some of which get overridden by each actual material).

Nothing new here for over a month, cannot do much really, so archiving for now.

This bug is still very much around in 2018.3.11f1. There is a post here that has particularly helpful details about a user's experience trying various albedo settings in Blender, and the corresponding (incorrect) results when importing the .FBX into Unity.

Hopefully on somebody's radar to fix? :)

Cameron Lewis (CamLewis) raised the priority of this task from Needs Information from User to Normal.Apr 2 2019, 11:26 PM
Bastien Montagne (mont29) lowered the priority of this task from Normal to Needs Information from User.Apr 3 2019, 7:59 AM

This is not adding anything new to the problem. Only thing that could help here is if someone with both e.g. Maya and Blender available, did some exports of dummy cube with a few sets of colors (exact same in both apps), checked that maya's FBX are working with Unity, and then put here all files, so that I can compare what difference there may be between Maya's and Blender's FBXs that could lead to that weird issue in Unity…

I might be able to help with that, actually. I'll circle back on it tomorr... wait, it's crazy late. So... today. :)

Cameron Lewis (CamLewis) raised the priority of this task from Needs Information from User to Normal.Apr 3 2019, 10:04 PM

Okay, here is an Assets folder that you'll hopefully be able to drop into a new project. Inside the scene you'll see three pairs of cubes.

From left to right, they are:

  • Two cubes with RGB opaque sides and RPG 25% transparency sides.
  • Two cubes that *should* be completely opaque, but only the Maya-exported one is.
  • Two cubes that should be totally opaque, but only the Maya-exported one is. Please note that with this one, the purple color is simply the "troublesome blue," but with the red channel turned all the way up. Why follows below.

The trouble appears to be that with Blender FBXs, transparency is taken from the value of the Red channel, rather than the Alpha channel. This is why any material with a Red value between 0 and 1 appears as correspondingly transparent once inside Unity. Could be Blender's export, could be Unity's FBX import, I really have no idea. I do hope that this info and these materials might be of value in squashing it.

I'm really just a neophyte, but I've tried to make everything uniform, scaling and orientation corrections aside. I'd never worked in Maya before today.

Please let me know what you reckon? :)

One correction: I think the imported Alpha value may actually be inversely proportional to the Red value, rather than a direct linear correspondence.

LazyDodo (LazyDodo) raised the priority of this task from Normal to Needs Triage by Developer.Apr 3 2019, 10:08 PM
Bastien Montagne (mont29) triaged this task as Confirmed, Medium priority.Apr 10 2019, 10:12 AM

Thanks for the files, I’ll check on them asap :)

I am still having the transparency problem when I export it as a certain material! When I export as green (which I don't want to), it works but when I export my model as a light skin tone, it is transparent. Do you have an answer yet Bastien Montangne?

No I don’t, I checked the files, and also there are some differences, cannot see any that should matter here, nor explain the issue. This is one more weird mystery to add to the ever growing FBX list. :(

That's a drag. Did the files at least help to confirm that the Red channel is interfering with the functioning of the Alpha channel in materials?

No. Colors come as expected in the files (see below the JSON versions of both maya and blender ones), and alpha in FBX material is a separated property, usually TransparencyFactor, also we have Opacity too…

Even worse, in your maya-exported file, TransparencyFactor is set to *1.0*, which, according to the SDK, is supposed to mean alpha 0 (fully transparent)… Fbx, fbx, fbx… if you can make some sense out of this, be my guest. ;)

Colored Cube (Maya 2018), Troublesome Blue with Full Red Channel FBX:

[
    ["FBXHeaderExtension", [], "", [
        ["FBXHeaderVersion", [1003], "I", []],
        ["FBXVersion", [7500], "I", []],
        ["EncryptionType", [0], "I", []],
        ["CreationTimeStamp", [], "", [
            ["Version", [1000], "I", []],
            ["Year", [2019], "I", []],
            ["Month", [4], "I", []],
            ["Day", [3], "I", []],
            ["Hour", [15], "I", []],
            ["Minute", [12], "I", []],
            ["Second", [20], "I", []],
            ["Millisecond", [865], "I", []]]],
        ["Creator", ["FBX SDK/FBX Plugins version 2018.1.1"], "S", []],
        ["SceneInfo", ["GlobalInfo::SceneInfo", "UserData"], "SS", [
            ["Type", ["UserData"], "S", []],
            ["Version", [100], "I", []],
            ["MetaData", [], "", [
                ["Version", [100], "I", []],
                ["Title", [""], "S", []],
                ["Subject", [""], "S", []],
                ["Author", [""], "S", []],
                ["Keywords", [""], "S", []],
                ["Revision", [""], "S", []],
                ["Comment", [""], "S", []]]],
            ["Properties70", [], "", [
                ["P", ["DocumentUrl", "KString", "Url", "", "D:\\Development Work\\Unity Projects\\Colored Cube Test\\Assets\\Meshes\\Colored Cube (Maya 2018), Troublesome Blue with Full Red Channel FBX.fbx"], "SSSSS", []],
                ["P", ["SrcDocumentUrl", "KString", "Url", "", "D:\\Development Work\\Unity Projects\\Colored Cube Test\\Assets\\Meshes\\Colored Cube (Maya 2018), Troublesome Blue with Full Red Channel FBX.fbx"], "SSSSS", []],
                ["P", ["Original", "Compound", "", ""], "SSSS", []],
                ["P", ["Original|ApplicationVendor", "KString", "", "", "Autodesk"], "SSSSS", []],
                ["P", ["Original|ApplicationName", "KString", "", "", "Maya"], "SSSSS", []],
                ["P", ["Original|ApplicationVersion", "KString", "", "", "201800"], "SSSSS", []],
                ["P", ["Original|DateTime_GMT", "DateTime", "", "", "03/04/2019 19:12:20.863"], "SSSSS", []],
                ["P", ["Original|FileName", "KString", "", "", "D:\\Development Work\\Unity Projects\\Colored Cube Test\\Assets\\Meshes\\Colored Cube (Maya 2018), Troublesome Blue with Full Red Channel FBX.fbx"], "SSSSS", []],
                ["P", ["LastSaved", "Compound", "", ""], "SSSS", []],
                ["P", ["LastSaved|ApplicationVendor", "KString", "", "", "Autodesk"], "SSSSS", []],
                ["P", ["LastSaved|ApplicationName", "KString", "", "", "Maya"], "SSSSS", []],
                ["P", ["LastSaved|ApplicationVersion", "KString", "", "", "201800"], "SSSSS", []],
                ["P", ["LastSaved|DateTime_GMT", "DateTime", "", "", "03/04/2019 19:12:20.863"], "SSSSS", []],
                ["P", ["Original|ApplicationActiveProject", "KString", "", "", "D:\\Development Work\\Unity Projects\\Colored Cube Test\\Assets\\Meshes"], "SSSSS", []],
                ["P", ["Original|ApplicationNativeFile", "KString", "", "", "D:\\Development Work\\Unity Projects\\Colored Cube Test\\Assets\\Meshes\\Colored Cube (Maya 2018), Troublesome Blue with Full Red Channel.mb"], "SSSSS", []]]]]]]],
    ["FileId", ["*\\xb1(\\xec\\xb1&\\xce\\xc2\\xb7\\xc6\\xbd.\\xab \\xf6\\xf9"], "R", []],
    ["CreationTime", ["2019-04-03 15:12:20:865"], "S", []],
    ["Creator", ["FBX SDK/FBX Plugins version 2018.1.1 build=20170505"], "S", []],
    ["GlobalSettings", [], "", [
        ["Version", [1000], "I", []],
        ["Properties70", [], "", [
            ["P", ["UpAxis", "int", "Integer", "", 1], "SSSSI", []],
            ["P", ["UpAxisSign", "int", "Integer", "", 1], "SSSSI", []],
            ["P", ["FrontAxis", "int", "Integer", "", 2], "SSSSI", []],
            ["P", ["FrontAxisSign", "int", "Integer", "", 1], "SSSSI", []],
            ["P", ["CoordAxis", "int", "Integer", "", 0], "SSSSI", []],
            ["P", ["CoordAxisSign", "int", "Integer", "", 1], "SSSSI", []],
            ["P", ["OriginalUpAxis", "int", "Integer", "", 1], "SSSSI", []],
            ["P", ["OriginalUpAxisSign", "int", "Integer", "", 1], "SSSSI", []],
            ["P", ["UnitScaleFactor", "double", "Number", "", 1.0], "SSSSD", []],
            ["P", ["OriginalUnitScaleFactor", "double", "Number", "", 1.0], "SSSSD", []],
            ["P", ["AmbientColor", "ColorRGB", "Color", "", 0.0, 0.0, 0.0], "SSSSDDD", []],
            ["P", ["DefaultCamera", "KString", "", "", "Producer Perspective"], "SSSSS", []],
            ["P", ["TimeMode", "enum", "", "", 11], "SSSSI", []],
            ["P", ["TimeProtocol", "enum", "", "", 2], "SSSSI", []],
            ["P", ["SnapOnFrameMode", "enum", "", "", 0], "SSSSI", []],
            ["P", ["TimeSpanStart", "KTime", "Time", "", 1924423250], "SSSSL", []],
            ["P", ["TimeSpanStop", "KTime", "Time", "", 384884650000], "SSSSL", []],
            ["P", ["CustomFrameRate", "double", "Number", "", -1.0], "SSSSD", []],
            ["P", ["TimeMarker", "Compound", "", ""], "SSSS", []],
            ["P", ["CurrentTimeMarker", "int", "Integer", "", -1], "SSSSI", []]]]]],
    ["Documents", [], "", [
        ["Count", [1], "I", []],
        ["Document", [1555673386976, "", "Scene"], "LSS", [
            ["Properties70", [], "", [
                ["P", ["SourceObject", "object", "", ""], "SSSS", []],
                ["P", ["ActiveAnimStackName", "KString", "", "", "Take 001"], "SSSSS", []]]],
            ["RootNode", [0], "L", []]]]]],
    ["References", [], "", []],
    ["Definitions", [], "", [
        ["Version", [100], "I", []],
        ["Count", [5], "I", []],
        ["ObjectType", ["GlobalSettings"], "S", [
            ["Count", [1], "I", []]]],
        ["ObjectType", ["Geometry"], "S", [
            ["Count", [1], "I", []],
            ["PropertyTemplate", ["FbxMesh"], "S", [
                ["Properties70", [], "", [
                    ["P", ["Color", "ColorRGB", "Color", "", 0.8, 0.8, 0.8], "SSSSDDD", []],
                    ["P", ["BBoxMin", "Vector3D", "Vector", "", 0.0, 0.0, 0.0], "SSSSDDD", []],
                    ["P", ["BBoxMax", "Vector3D", "Vector", "", 0.0, 0.0, 0.0], "SSSSDDD", []],
                    ["P", ["Primary Visibility", "bool", "", "", 1], "SSSSI", []],
                    ["P", ["Casts Shadows", "bool", "", "", 1], "SSSSI", []],
                    ["P", ["Receive Shadows", "bool", "", "", 1], "SSSSI", []]]]]]]],
        ["ObjectType", ["Material"], "S", [
            ["Count", [2], "I", []],
            ["PropertyTemplate", ["FbxSurfacePhong"], "S", [
                ["Properties70", [], "", [
                    ["P", ["ShadingModel", "KString", "", "", "Phong"], "SSSSS", []],
                    ["P", ["MultiLayer", "bool", "", "", 0], "SSSSI", []],
                    ["P", ["EmissiveColor", "Color", "", "A", 0.0, 0.0, 0.0], "SSSSDDD", []],
                    ["P", ["EmissiveFactor", "Number", "", "A", 1.0], "SSSSD", []],
                    ["P", ["AmbientColor", "Color", "", "A", 0.2, 0.2, 0.2], "SSSSDDD", []],
                    ["P", ["AmbientFactor", "Number", "", "A", 1.0], "SSSSD", []],
                    ["P", ["DiffuseColor", "Color", "", "A", 0.8, 0.8, 0.8], "SSSSDDD", []],
                    ["P", ["DiffuseFactor", "Number", "", "A", 1.0], "SSSSD", []],
                    ["P", ["Bump", "Vector3D", "Vector", "", 0.0, 0.0, 0.0], "SSSSDDD", []],
                    ["P", ["NormalMap", "Vector3D", "Vector", "", 0.0, 0.0, 0.0], "SSSSDDD", []],
                    ["P", ["BumpFactor", "double", "Number", "", 1.0], "SSSSD", []],
                    ["P", ["TransparentColor", "Color", "", "A", 0.0, 0.0, 0.0], "SSSSDDD", []],
                    ["P", ["TransparencyFactor", "Number", "", "A", 0.0], "SSSSD", []],
                    ["P", ["DisplacementColor", "ColorRGB", "Color", "", 0.0, 0.0, 0.0], "SSSSDDD", []],
                    ["P", ["DisplacementFactor", "double", "Number", "", 1.0], "SSSSD", []],
                    ["P", ["VectorDisplacementColor", "ColorRGB", "Color", "", 0.0, 0.0, 0.0], "SSSSDDD", []],
                    ["P", ["VectorDisplacementFactor", "double", "Number", "", 1.0], "SSSSD", []],
                    ["P", ["SpecularColor", "Color", "", "A", 0.2, 0.2, 0.2], "SSSSDDD", []],
                    ["P", ["SpecularFactor", "Number", "", "A", 1.0], "SSSSD", []],
                    ["P", ["ShininessExponent", "Number", "", "A", 20.0], "SSSSD", []],
                    ["P", ["ReflectionColor", "Color", "", "A", 0.0, 0.0, 0.0], "SSSSDDD", []],
                    ["P", ["ReflectionFactor", "Number", "", "A", 1.0], "SSSSD", []]]]]]]],
        ["ObjectType", ["Model"], "S", [
            ["Count", [1], "I", []],
            ["PropertyTemplate", ["FbxNode"], "S", [
                ["Properties70", [], "", [
                    ["P", ["QuaternionInterpolate", "enum", "", "", 0], "SSSSI", []],
                    ["P", ["RotationOffset", "Vector3D", "Vector", "", 0.0, 0.0, 0.0], "SSSSDDD", []],
                    ["P", ["RotationPivot", "Vector3D", "Vector", "", 0.0, 0.0, 0.0], "SSSSDDD", []],
                    ["P", ["ScalingOffset", "Vector3D", "Vector", "", 0.0, 0.0, 0.0], "SSSSDDD", []],
                    ["P", ["ScalingPivot", "Vector3D", "Vector", "", 0.0, 0.0, 0.0], "SSSSDDD", []],
                    ["P", ["TranslationActive", "bool", "", "", 0], "SSSSI", []],
                    ["P", ["TranslationMin", "Vector3D", "Vector", "", 0.0, 0.0, 0.0], "SSSSDDD", []],
                    ["P", ["TranslationMax", "Vector3D", "Vector", "", 0.0, 0.0, 0.0], "SSSSDDD", []],
                    ["P", ["TranslationMinX", "bool", "", "", 0], "SSSSI", []],
                    ["P", ["TranslationMinY", "bool", "", "", 0], "SSSSI", []],
                    ["P", ["TranslationMinZ", "bool", "", "", 0], "SSSSI", []],
                    ["P", ["TranslationMaxX", "bool", "", "", 0], "SSSSI", []],
                    ["P", ["TranslationMaxY", "bool", "", "", 0], "SSSSI", []],
                    ["P", ["TranslationMaxZ", "bool", "", "", 0], "SSSSI", []],
                    ["P", ["RotationOrder", "enum", "", "", 0], "SSSSI", []],
                    ["P", ["RotationSpaceForLimitOnly", "bool", "", "", 0], "SSSSI", []],
                    ["P", ["RotationStiffnessX", "double", "Number", "", 0.0], "SSSSD", []],
                    ["P", ["RotationStiffnessY", "double", "Number", "", 0.0], "SSSSD", []],
                    ["P", ["RotationStiffnessZ", "double", "Number", "", 0.0], "SSSSD", []],
                    ["P", ["AxisLen", "double", "Number", "", 10.0], "SSSSD", []],
                    ["P", ["PreRotation", "Vector3D", "Vector", "", 0.0, 0.0, 0.0], "SSSSDDD", []],
                    ["P", ["PostRotation", "Vector3D", "Vector", "", 0.0, 0.0, 0.0], "SSSSDDD", []],
                    ["P", ["RotationActive", "bool", "", "", 0], "SSSSI", []],
                    ["P", ["RotationMin", "Vector3D", "Vector", "", 0.0, 0.0, 0.0], "SSSSDDD", []],
                    ["P", ["RotationMax", "Vector3D", "Vector", "", 0.0, 0.0, 0.0], "SSSSDDD", []],
                    ["P", ["RotationMinX", "bool", "", "", 0], "SSSSI", []],
                    ["P", ["RotationMinY", "bool", "", "", 0], "SSSSI", []],
                    ["P", ["RotationMinZ", "bool", "", "", 0], "SSSSI", []],
                    ["P", ["RotationMaxX", "bool", "", "", 0], "SSSSI", []],
                    ["P", ["RotationMaxY", "bool", "", "", 0], "SSSSI", []],
                    ["P", ["RotationMaxZ", "bool", "", "", 0], "SSSSI", []],
                    ["P", ["InheritType", "enum", "", "", 0], "SSSSI", []],
                    ["P", ["ScalingActive", "bool", "", "", 0], "SSSSI", []],
                    ["P", ["ScalingMin", "Vector3D", "Vector", "", 0.0, 0.0, 0.0], "SSSSDDD", []],
                    ["P", ["ScalingMax", "Vector3D", "Vector", "", 1.0, 1.0, 1.0], "SSSSDDD", []],
                    ["P", ["ScalingMinX", "bool", "", "", 0], "SSSSI", []],
                    ["P", ["ScalingMinY", "bool", "", "", 0], "SSSSI", []],
                    ["P", ["ScalingMinZ", "bool", "", "", 0], "SSSSI", []],
                    ["P", ["ScalingMaxX", "bool", "", "", 0], "SSSSI", []],
                    ["P", ["ScalingMaxY", "bool", "", "", 0], "SSSSI", []],
                    ["P", ["ScalingMaxZ", "bool", "", "", 0], "SSSSI", []],
                    ["P", ["GeometricTranslation", "Vector3D", "Vector", "", 0.0, 0.0, 0.0], "SSSSDDD", []],
                    ["P", ["GeometricRotation", "Vector3D", "Vector", "", 0.0, 0.0, 0.0], "SSSSDDD", []],
                    ["P", ["GeometricScaling", "Vector3D", "Vector", "", 1.0, 1.0, 1.0], "SSSSDDD", []],
                    ["P", ["MinDampRangeX", "double", "Number", "", 0.0], "SSSSD", []],
                    ["P", ["MinDampRangeY", "double", "Number", "", 0.0], "SSSSD", []],
                    ["P", ["MinDampRangeZ", "double", "Number", "", 0.0], "SSSSD", []],
                    ["P", ["MaxDampRangeX", "double", "Number", "", 0.0], "SSSSD", []],
                    ["P", ["MaxDampRangeY", "double", "Number", "", 0.0], "SSSSD", []],
                    ["P", ["MaxDampRangeZ", "double", "Number", "", 0.0], "SSSSD", []],
                    ["P", ["MinDampStrengthX", "double", "Number", "", 0.0], "SSSSD", []],
                    ["P", ["MinDampStrengthY", "double", "Number", "", 0.0], "SSSSD", []],
                    ["P", ["MinDampStrengthZ", "double", "Number", "", 0.0], "SSSSD", []],
                    ["P", ["MaxDampStrengthX", "double", "Number", "", 0.0], "SSSSD", []],
                    ["P", ["MaxDampStrengthY", "double", "Number", "", 0.0], "SSSSD", []],
                    ["P", ["MaxDampStrengthZ", "double", "Number", "", 0.0], "SSSSD", []],
                    ["P", ["PreferedAngleX", "double", "Number", "", 0.0], "SSSSD", []],
                    ["P", ["PreferedAngleY", "double", "Number", "", 0.0], "SSSSD", []],
                    ["P", ["PreferedAngleZ", "double", "Number", "", 0.0], "SSSSD", []],
                    ["P", ["LookAtProperty", "object", "", ""], "SSSS", []],
                    ["P", ["UpVectorProperty", "object", "", ""], "SSSS", []],
                    ["P", ["Show", "bool", "", "", 1], "SSSSI", []],
                    ["P", ["NegativePercentShapeSupport", "bool", "", "", 1], "SSSSI", []],
                    ["P", ["DefaultAttributeIndex", "int", "Integer", "", -1], "SSSSI", []],
                    ["P", ["Freeze", "bool", "", "", 0], "SSSSI", []],
                    ["P", ["LODBox", "bool", "", "", 0], "SSSSI", []],
                    ["P", ["Lcl Translation", "Lcl Translation", "", "A", 0.0, 0.0, 0.0], "SSSSDDD", []],
                    ["P", ["Lcl Rotation", "Lcl Rotation", "", "A", 0.0, 0.0, 0.0], "SSSSDDD", []],
                    ["P", ["Lcl Scaling", "Lcl Scaling", "", "A", 1.0, 1.0, 1.0], "SSSSDDD", []],
                    ["P", ["Visibility", "Visibility", "", "A", 1.0], "SSSSD", []],
                    ["P", ["Visibility Inheritance", "Visibility Inheritance", "", "", 1], "SSSSI", []]]]]]]]]],
    ["Objects", [], "", [
        ["Geometry", [1555644367712, "::Geometry", "Mesh"], "LSS", [
            ["Vertices", [[-0.5, -0.5, 0.5, 0.5, -0.5, 0.5, -0.5, 0.5, 0.5, 0.5, 0.5, 0.5, -0.5, 0.5, -0.5, 0.5, 0.5, -0.5, -0.5, -0.5, -0.5, 0.5, -0.5, -0.5]], "d", []],
            ["PolygonVertexIndex", [[0, 1, 3, -3, 2, 3, 5, -5, 4, 5, 7, -7, 6, 7, 1, -1, 1, 7, 5, -4, 6, 0, 2, -5]], "i", []],
            ["Edges", [[0, 2, 6, 10, 3, 1, 7, 5, 11, 9, 15, 13]], "i", []],
            ["GeometryVersion", [124], "I", []],
            ["LayerElementNormal", [0], "I", [
                ["Version", [102], "I", []],
                ["Name", [""], "S", []],
                ["MappingInformationType", ["ByPolygonVertex"], "S", []],
                ["ReferenceInformationType", ["Direct"], "S", []],
                ["Normals", [[0.0, 0.0, 1.0, 0.0, 0.0, 1.0, 0.0, 0.0, 1.0, 0.0, 0.0, 1.0, 0.0, 1.0, 0.0, 0.0, 1.0, 0.0, 0.0, 1.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, -1.0, 0.0, 0.0, -1.0, 0.0, 0.0, -1.0, 0.0, 0.0, -1.0, 0.0, -1.0, 0.0, 0.0, -1.0, 0.0, 0.0, -1.0, 0.0, 0.0, -1.0, 0.0, 1.0, 0.0, 0.0, 1.0, 0.0, 0.0, 1.0, 0.0, 0.0, 1.0, 0.0, 0.0, -1.0, 0.0, 0.0, -1.0, 0.0, 0.0, -1.0, 0.0, 0.0, -1.0, 0.0, 0.0]], "d", []],
                ["NormalsW", [[1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0]], "d", []]]],
            ["LayerElementUV", [0], "I", [
                ["Version", [101], "I", []],
                ["Name", ["map1"], "S", []],
                ["MappingInformationType", ["ByPolygonVertex"], "S", []],
                ["ReferenceInformationType", ["IndexToDirect"], "S", []],
                ["UV", [[0.375, 0.0, 0.625, 0.0, 0.375, 0.25, 0.625, 0.25, 0.375, 0.5, 0.625, 0.5, 0.375, 0.75, 0.625, 0.75, 0.375, 1.0, 0.625, 1.0, 0.875, 0.0, 0.875, 0.25, 0.125, 0.0, 0.125, 0.25]], "d", []],
                ["UVIndex", [[0, 1, 3, 2, 2, 3, 5, 4, 4, 5, 7, 6, 6, 7, 9, 8, 1, 10, 11, 3, 12, 0, 2, 13]], "i", []]]],
            ["LayerElementMaterial", [0], "I", [
                ["Version", [101], "I", []],
                ["Name", [""], "S", []],
                ["MappingInformationType", ["ByPolygon"], "S", []],
                ["ReferenceInformationType", ["IndexToDirect"], "S", []],
                ["Materials", [[0, 0, 1, 1, 1, 0]], "i", []]]],
            ["Layer", [0], "I", [
                ["Version", [100], "I", []],
                ["LayerElement", [], "", [
                    ["Type", ["LayerElementNormal"], "S", []],
                    ["TypedIndex", [0], "I", []]]],
                ["LayerElement", [], "", [
                    ["Type", ["LayerElementMaterial"], "S", []],
                    ["TypedIndex", [0], "I", []]]],
                ["LayerElement", [], "", [
                    ["Type", ["LayerElementUV"], "S", []],
                    ["TypedIndex", [0], "I", []]]]]]]],
        ["Model", [1555689051872, "pCube1::Model", "Mesh"], "LSS", [
            ["Version", [232], "I", []],
            ["Properties70", [], "", [
                ["P", ["RotationActive", "bool", "", "", 1], "SSSSI", []],
                ["P", ["InheritType", "enum", "", "", 1], "SSSSI", []],
                ["P", ["ScalingMax", "Vector3D", "Vector", "", 0.0, 0.0, 0.0], "SSSSDDD", []],
                ["P", ["DefaultAttributeIndex", "int", "Integer", "", 0], "SSSSI", []],
                ["P", ["currentUVSet", "KString", "", "U", "map1"], "SSSSS", []]]],
            ["Shading", [true], "C", []],
            ["Culling", ["CullingOff"], "S", []]]],
        ["Material", [1555645356496, "Troublesome_Blue::Material", ""], "LSS", [
            ["Version", [102], "I", []],
            ["ShadingModel", ["phong"], "S", []],
            ["MultiLayer", [0], "I", []],
            ["Properties70", [], "", [
                ["P", ["AmbientColor", "Color", "", "A", 0.0, 0.0, 0.0], "SSSSDDD", []],
                ["P", ["DiffuseColor", "Color", "", "A", 0.032999999821186066, 0.12200000137090683, 0.5], "SSSSDDD", []],
                ["P", ["DiffuseFactor", "Number", "", "A", 0.800000011920929], "SSSSD", []],
                ["P", ["TransparencyFactor", "Number", "", "A", 1.0], "SSSSD", []],
                ["P", ["SpecularColor", "Color", "", "A", 0.5, 0.5, 0.5], "SSSSDDD", []],
                ["P", ["ReflectionFactor", "Number", "", "A", 0.5], "SSSSD", []],
                ["P", ["Emissive", "Vector3D", "Vector", "", 0.0, 0.0, 0.0], "SSSSDDD", []],
                ["P", ["Ambient", "Vector3D", "Vector", "", 0.0, 0.0, 0.0], "SSSSDDD", []],
                ["P", ["Diffuse", "Vector3D", "Vector", "", 0.026400000250339506, 0.09760000255107881, 0.4000000059604645], "SSSSDDD", []],
                ["P", ["Specular", "Vector3D", "Vector", "", 0.5, 0.5, 0.5], "SSSSDDD", []],
                ["P", ["Shininess", "double", "Number", "", 20.0], "SSSSD", []],
                ["P", ["Opacity", "double", "Number", "", 1.0], "SSSSD", []],
                ["P", ["Reflectivity", "double", "Number", "", 0.0], "SSSSD", []]]]]],
        ["Material", [1555645365136, "Troublesome_Blue_with_Full_Red_Channel::Material", ""], "LSS", [
            ["Version", [102], "I", []],
            ["ShadingModel", ["phong"], "S", []],
            ["MultiLayer", [0], "I", []],
            ["Properties70", [], "", [
                ["P", ["AmbientColor", "Color", "", "A", 0.0, 0.0, 0.0], "SSSSDDD", []],
                ["P", ["DiffuseColor", "Color", "", "A", 1.0, 0.12200000137090683, 0.800000011920929], "SSSSDDD", []],
                ["P", ["DiffuseFactor", "Number", "", "A", 0.800000011920929], "SSSSD", []],
                ["P", ["TransparencyFactor", "Number", "", "A", 1.0], "SSSSD", []],
                ["P", ["SpecularColor", "Color", "", "A", 0.5, 0.5, 0.5], "SSSSDDD", []],
                ["P", ["ReflectionFactor", "Number", "", "A", 0.5], "SSSSD", []],
                ["P", ["Emissive", "Vector3D", "Vector", "", 0.0, 0.0, 0.0], "SSSSDDD", []],
                ["P", ["Ambient", "Vector3D", "Vector", "", 0.0, 0.0, 0.0], "SSSSDDD", []],
                ["P", ["Diffuse", "Vector3D", "Vector", "", 0.800000011920929, 0.09760000255107881, 0.6400000190734865], "SSSSDDD", []],
                ["P", ["Specular", "Vector3D", "Vector", "", 0.5, 0.5, 0.5], "SSSSDDD", []],
                ["P", ["Shininess", "double", "Number", "", 20.0], "SSSSD", []],
                ["P", ["Opacity", "double", "Number", "", 1.0], "SSSSD", []],
                ["P", ["Reflectivity", "double", "Number", "", 0.0], "SSSSD", []]]]]]]],
    ["Connections", [], "", [
        ["C", ["OO", 1555689051872, 0], "SLL", []],
        ["C", ["OO", 1555644367712, 1555689051872], "SLL", []],
        ["C", ["OO", 1555645356496, 1555689051872], "SLL", []],
        ["C", ["OO", 1555645365136, 1555689051872], "SLL", []]]]]

Colored Cube (Blender 2.8), Troublesome Blue with Full Red Channel FBX:

[
    ["FBXHeaderExtension", [], "", [
        ["FBXHeaderVersion", [1003], "I", []],
        ["FBXVersion", [7400], "I", []],
        ["EncryptionType", [0], "I", []],
        ["CreationTimeStamp", [], "", [
            ["Version", [1000], "I", []],
            ["Year", [2019], "I", []],
            ["Month", [4], "I", []],
            ["Day", [3], "I", []],
            ["Hour", [15], "I", []],
            ["Minute", [14], "I", []],
            ["Second", [58], "I", []],
            ["Millisecond", [79], "I", []]]],
        ["Creator", ["Blender (stable FBX IO) - 2.80 (sub 53) - 4.14.5"], "S", []],
        ["SceneInfo", ["GlobalInfo::SceneInfo", "UserData"], "SS", [
            ["Type", ["UserData"], "S", []],
            ["Version", [100], "I", []],
            ["MetaData", [], "", [
                ["Version", [100], "I", []],
                ["Title", [""], "S", []],
                ["Subject", [""], "S", []],
                ["Author", [""], "S", []],
                ["Keywords", [""], "S", []],
                ["Revision", [""], "S", []],
                ["Comment", [""], "S", []]]],
            ["Properties70", [], "", [
                ["P", ["DocumentUrl", "KString", "Url", "", "/foobar.fbx"], "SSSSS", []],
                ["P", ["SrcDocumentUrl", "KString", "Url", "", "/foobar.fbx"], "SSSSS", []],
                ["P", ["Original", "Compound", "", ""], "SSSS", []],
                ["P", ["Original|ApplicationVendor", "KString", "", "", "Blender Foundation"], "SSSSS", []],
                ["P", ["Original|ApplicationName", "KString", "", "", "Blender (stable FBX IO)"], "SSSSS", []],
                ["P", ["Original|ApplicationVersion", "KString", "", "", "2.80 (sub 53)"], "SSSSS", []],
                ["P", ["Original|DateTime_GMT", "DateTime", "", "", "01/01/1970 00:00:00.000"], "SSSSS", []],
                ["P", ["Original|FileName", "KString", "", "", "/foobar.fbx"], "SSSSS", []],
                ["P", ["LastSaved", "Compound", "", ""], "SSSS", []],
                ["P", ["LastSaved|ApplicationVendor", "KString", "", "", "Blender Foundation"], "SSSSS", []],
                ["P", ["LastSaved|ApplicationName", "KString", "", "", "Blender (stable FBX IO)"], "SSSSS", []],
                ["P", ["LastSaved|ApplicationVersion", "KString", "", "", "2.80 (sub 53)"], "SSSSS", []],
                ["P", ["LastSaved|DateTime_GMT", "DateTime", "", "", "01/01/1970 00:00:00.000"], "SSSSS", []]]]]]]],
    ["FileId", ["(\\xb3*\\xeb\\xb6$\\xcc\\xc2\\xbf\\xc8\\xb0*\\xa9+\\xfc\\xf1"], "R", []],
    ["CreationTime", ["1970-01-01 10:00:00:000"], "S", []],
    ["Creator", ["Blender (stable FBX IO) - 2.80 (sub 53) - 4.14.5"], "S", []],
    ["GlobalSettings", [], "", [
        ["Version", [1000], "I", []],
        ["Properties70", [], "", [
            ["P", ["UpAxis", "int", "Integer", "", 1], "SSSSI", []],
            ["P", ["UpAxisSign", "int", "Integer", "", 1], "SSSSI", []],
            ["P", ["FrontAxis", "int", "Integer", "", 2], "SSSSI", []],
            ["P", ["FrontAxisSign", "int", "Integer", "", 1], "SSSSI", []],
            ["P", ["CoordAxis", "int", "Integer", "", 0], "SSSSI", []],
            ["P", ["CoordAxisSign", "int", "Integer", "", 1], "SSSSI", []],
            ["P", ["OriginalUpAxis", "int", "Integer", "", -1], "SSSSI", []],
            ["P", ["OriginalUpAxisSign", "int", "Integer", "", 1], "SSSSI", []],
            ["P", ["UnitScaleFactor", "double", "Number", "", 1.0], "SSSSD", []],
            ["P", ["OriginalUnitScaleFactor", "double", "Number", "", 1.0], "SSSSD", []],
            ["P", ["AmbientColor", "ColorRGB", "Color", "", 0.0, 0.0, 0.0], "SSSSDDD", []],
            ["P", ["DefaultCamera", "KString", "", "", "Producer Perspective"], "SSSSS", []],
            ["P", ["TimeMode", "enum", "", "", 11], "SSSSI", []],
            ["P", ["TimeSpanStart", "KTime", "Time", "", 0], "SSSSL", []],
            ["P", ["TimeSpanStop", "KTime", "Time", "", 46186158000], "SSSSL", []],
            ["P", ["CustomFrameRate", "double", "Number", "", 24.0], "SSSSD", []]]]]],
    ["Documents", [], "", [
        ["Count", [1], "I", []],
        ["Document", [329657182, "Scene", "Scene"], "LSS", [
            ["Properties70", [], "", [
                ["P", ["SourceObject", "object", "", ""], "SSSS", []],
                ["P", ["ActiveAnimStackName", "KString", "", "", ""], "SSSSS", []]]],
            ["RootNode", [0], "L", []]]]]],
    ["References", [], "", []],
    ["Definitions", [], "", [
        ["Version", [100], "I", []],
        ["Count", [5], "I", []],
        ["ObjectType", ["GlobalSettings"], "S", [
            ["Count", [1], "I", []]]],
        ["ObjectType", ["Geometry"], "S", [
            ["Count", [1], "I", []],
            ["PropertyTemplate", ["FbxMesh"], "S", [
                ["Properties70", [], "", [
                    ["P", ["Color", "ColorRGB", "Color", "", 0.8, 0.8, 0.8], "SSSSDDD", []],
                    ["P", ["BBoxMin", "Vector3D", "Vector", "", 0.0, 0.0, 0.0], "SSSSDDD", []],
                    ["P", ["BBoxMax", "Vector3D", "Vector", "", 0.0, 0.0, 0.0], "SSSSDDD", []],
                    ["P", ["Primary Visibility", "bool", "", "", 1], "SSSSI", []],
                    ["P", ["Casts Shadows", "bool", "", "", 1], "SSSSI", []],
                    ["P", ["Receive Shadows", "bool", "", "", 1], "SSSSI", []]]]]]]],
        ["ObjectType", ["Model"], "S", [
            ["Count", [1], "I", []],
            ["PropertyTemplate", ["FbxNode"], "S", [
                ["Properties70", [], "", [
                    ["P", ["QuaternionInterpolate", "enum", "", "", 0], "SSSSI", []],
                    ["P", ["RotationOffset", "Vector3D", "Vector", "", 0.0, 0.0, 0.0], "SSSSDDD", []],
                    ["P", ["RotationPivot", "Vector3D", "Vector", "", 0.0, 0.0, 0.0], "SSSSDDD", []],
                    ["P", ["ScalingOffset", "Vector3D", "Vector", "", 0.0, 0.0, 0.0], "SSSSDDD", []],
                    ["P", ["ScalingPivot", "Vector3D", "Vector", "", 0.0, 0.0, 0.0], "SSSSDDD", []],
                    ["P", ["TranslationActive", "bool", "", "", 0], "SSSSI", []],
                    ["P", ["TranslationMin", "Vector3D", "Vector", "", 0.0, 0.0, 0.0], "SSSSDDD", []],
                    ["P", ["TranslationMax", "Vector3D", "Vector", "", 0.0, 0.0, 0.0], "SSSSDDD", []],
                    ["P", ["TranslationMinX", "bool", "", "", 0], "SSSSI", []],
                    ["P", ["TranslationMinY", "bool", "", "", 0], "SSSSI", []],
                    ["P", ["TranslationMinZ", "bool", "", "", 0], "SSSSI", []],
                    ["P", ["TranslationMaxX", "bool", "", "", 0], "SSSSI", []],
                    ["P", ["TranslationMaxY", "bool", "", "", 0], "SSSSI", []],
                    ["P", ["TranslationMaxZ", "bool", "", "", 0], "SSSSI", []],
                    ["P", ["RotationOrder", "enum", "", "", 0], "SSSSI", []],
                    ["P", ["RotationSpaceForLimitOnly", "bool", "", "", 0], "SSSSI", []],
                    ["P", ["RotationStiffnessX", "double", "Number", "", 0.0], "SSSSD", []],
                    ["P", ["RotationStiffnessY", "double", "Number", "", 0.0], "SSSSD", []],
                    ["P", ["RotationStiffnessZ", "double", "Number", "", 0.0], "SSSSD", []],
                    ["P", ["AxisLen", "double", "Number", "", 10.0], "SSSSD", []],
                    ["P", ["PreRotation", "Vector3D", "Vector", "", 0.0, 0.0, 0.0], "SSSSDDD", []],
                    ["P", ["PostRotation", "Vector3D", "Vector", "", 0.0, 0.0, 0.0], "SSSSDDD", []],
                    ["P", ["RotationActive", "bool", "", "", 0], "SSSSI", []],
                    ["P", ["RotationMin", "Vector3D", "Vector", "", 0.0, 0.0, 0.0], "SSSSDDD", []],
                    ["P", ["RotationMax", "Vector3D", "Vector", "", 0.0, 0.0, 0.0], "SSSSDDD", []],
                    ["P", ["RotationMinX", "bool", "", "", 0], "SSSSI", []],
                    ["P", ["RotationMinY", "bool", "", "", 0], "SSSSI", []],
                    ["P", ["RotationMinZ", "bool", "", "", 0], "SSSSI", []],
                    ["P", ["RotationMaxX", "bool", "", "", 0], "SSSSI", []],
                    ["P", ["RotationMaxY", "bool", "", "", 0], "SSSSI", []],
                    ["P", ["RotationMaxZ", "bool", "", "", 0], "SSSSI", []],
                    ["P", ["InheritType", "enum", "", "", 0], "SSSSI", []],
                    ["P", ["ScalingActive", "bool", "", "", 0], "SSSSI", []],
                    ["P", ["ScalingMin", "Vector3D", "Vector", "", 0.0, 0.0, 0.0], "SSSSDDD", []],
                    ["P", ["ScalingMax", "Vector3D", "Vector", "", 1.0, 1.0, 1.0], "SSSSDDD", []],
                    ["P", ["ScalingMinX", "bool", "", "", 0], "SSSSI", []],
                    ["P", ["ScalingMinY", "bool", "", "", 0], "SSSSI", []],
                    ["P", ["ScalingMinZ", "bool", "", "", 0], "SSSSI", []],
                    ["P", ["ScalingMaxX", "bool", "", "", 0], "SSSSI", []],
                    ["P", ["ScalingMaxY", "bool", "", "", 0], "SSSSI", []],
                    ["P", ["ScalingMaxZ", "bool", "", "", 0], "SSSSI", []],
                    ["P", ["GeometricTranslation", "Vector3D", "Vector", "", 0.0, 0.0, 0.0], "SSSSDDD", []],
                    ["P", ["GeometricRotation", "Vector3D", "Vector", "", 0.0, 0.0, 0.0], "SSSSDDD", []],
                    ["P", ["GeometricScaling", "Vector3D", "Vector", "", 1.0, 1.0, 1.0], "SSSSDDD", []],
                    ["P", ["MinDampRangeX", "double", "Number", "", 0.0], "SSSSD", []],
                    ["P", ["MinDampRangeY", "double", "Number", "", 0.0], "SSSSD", []],
                    ["P", ["MinDampRangeZ", "double", "Number", "", 0.0], "SSSSD", []],
                    ["P", ["MaxDampRangeX", "double", "Number", "", 0.0], "SSSSD", []],
                    ["P", ["MaxDampRangeY", "double", "Number", "", 0.0], "SSSSD", []],
                    ["P", ["MaxDampRangeZ", "double", "Number", "", 0.0], "SSSSD", []],
                    ["P", ["MinDampStrengthX", "double", "Number", "", 0.0], "SSSSD", []],
                    ["P", ["MinDampStrengthY", "double", "Number", "", 0.0], "SSSSD", []],
                    ["P", ["MinDampStrengthZ", "double", "Number", "", 0.0], "SSSSD", []],
                    ["P", ["MaxDampStrengthX", "double", "Number", "", 0.0], "SSSSD", []],
                    ["P", ["MaxDampStrengthY", "double", "Number", "", 0.0], "SSSSD", []],
                    ["P", ["MaxDampStrengthZ", "double", "Number", "", 0.0], "SSSSD", []],
                    ["P", ["PreferedAngleX", "double", "Number", "", 0.0], "SSSSD", []],
                    ["P", ["PreferedAngleY", "double", "Number", "", 0.0], "SSSSD", []],
                    ["P", ["PreferedAngleZ", "double", "Number", "", 0.0], "SSSSD", []],
                    ["P", ["LookAtProperty", "object", "", ""], "SSSS", []],
                    ["P", ["UpVectorProperty", "object", "", ""], "SSSS", []],
                    ["P", ["Show", "bool", "", "", 1], "SSSSI", []],
                    ["P", ["NegativePercentShapeSupport", "bool", "", "", 1], "SSSSI", []],
                    ["P", ["DefaultAttributeIndex", "int", "Integer", "", -1], "SSSSI", []],
                    ["P", ["Freeze", "bool", "", "", 0], "SSSSI", []],
                    ["P", ["LODBox", "bool", "", "", 0], "SSSSI", []],
                    ["P", ["Lcl Translation", "Lcl Translation", "", "A", 0.0, 0.0, 0.0], "SSSSDDD", []],
                    ["P", ["Lcl Rotation", "Lcl Rotation", "", "A", 0.0, 0.0, 0.0], "SSSSDDD", []],
                    ["P", ["Lcl Scaling", "Lcl Scaling", "", "A", 1.0, 1.0, 1.0], "SSSSDDD", []],
                    ["P", ["Visibility", "Visibility", "", "A", 1.0], "SSSSD", []],
                    ["P", ["Visibility Inheritance", "Visibility Inheritance", "", "", 1], "SSSSI", []]]]]]]],
        ["ObjectType", ["Material"], "S", [
            ["Count", [2], "I", []],
            ["PropertyTemplate", ["FbxSurfacePhong"], "S", [
                ["Properties70", [], "", [
                    ["P", ["ShadingModel", "KString", "", "", "Phong"], "SSSSS", []],
                    ["P", ["MultiLayer", "bool", "", "", 0], "SSSSI", []],
                    ["P", ["EmissiveColor", "Color", "", "A", 0.0, 0.0, 0.0], "SSSSDDD", []],
                    ["P", ["EmissiveFactor", "Number", "", "A", 1.0], "SSSSD", []],
                    ["P", ["AmbientColor", "Color", "", "A", 0.2, 0.2, 0.2], "SSSSDDD", []],
                    ["P", ["AmbientFactor", "Number", "", "A", 1.0], "SSSSD", []],
                    ["P", ["DiffuseColor", "Color", "", "A", 0.8, 0.8, 0.8], "SSSSDDD", []],
                    ["P", ["DiffuseFactor", "Number", "", "A", 1.0], "SSSSD", []],
                    ["P", ["TransparentColor", "Color", "", "A", 0.0, 0.0, 0.0], "SSSSDDD", []],
                    ["P", ["TransparencyFactor", "Number", "", "A", 0.0], "SSSSD", []],
                    ["P", ["Opacity", "Number", "", "A", 1.0], "SSSSD", []],
                    ["P", ["NormalMap", "Vector3D", "Vector", "", 0.0, 0.0, 0.0], "SSSSDDD", []],
                    ["P", ["Bump", "Vector3D", "Vector", "", 0.0, 0.0, 0.0], "SSSSDDD", []],
                    ["P", ["BumpFactor", "double", "Number", "", 1.0], "SSSSD", []],
                    ["P", ["DisplacementColor", "ColorRGB", "Color", "", 0.0, 0.0, 0.0], "SSSSDDD", []],
                    ["P", ["DisplacementFactor", "double", "Number", "", 1.0], "SSSSD", []],
                    ["P", ["VectorDisplacementColor", "ColorRGB", "Color", "", 0.0, 0.0, 0.0], "SSSSDDD", []],
                    ["P", ["VectorDisplacementFactor", "double", "Number", "", 1.0], "SSSSD", []],
                    ["P", ["SpecularColor", "Color", "", "A", 0.2, 0.2, 0.2], "SSSSDDD", []],
                    ["P", ["SpecularFactor", "Number", "", "A", 1.0], "SSSSD", []],
                    ["P", ["Shininess", "Number", "", "A", 20.0], "SSSSD", []],
                    ["P", ["ShininessExponent", "Number", "", "A", 20.0], "SSSSD", []],
                    ["P", ["ReflectionColor", "Color", "", "A", 0.0, 0.0, 0.0], "SSSSDDD", []],
                    ["P", ["ReflectionFactor", "Number", "", "A", 1.0], "SSSSD", []]]]]]]]]],
    ["Objects", [], "", [
        ["Geometry", [648153506, "Cube::Geometry", "Mesh"], "LSS", [
            ["Properties70", [], "", []],
            ["GeometryVersion", [124], "I", []],
            ["Vertices", [[1.0, 1.0, 1.0, 1.0, 1.0, -1.0, 1.0, -1.0, 1.0, 1.0, -1.0, -1.0, -1.0, 1.0, 1.0, -1.0, 1.0, -1.0, -1.0, -1.0, 1.0, -1.0, -1.0, -1.0]], "d", []],
            ["PolygonVertexIndex", [[0, 4, 6, -3, 3, 2, 6, -8, 7, 6, 4, -6, 5, 1, 3, -8, 1, 0, 2, -4, 5, 4, 0, -2]], "i", []],
            ["Edges", [[0, 1, 2, 3, 4, 6, 7, 10, 11, 12, 13, 16]], "i", []],
            ["LayerElementNormal", [0], "I", [
                ["Version", [101], "I", []],
                ["Name", [""], "S", []],
                ["MappingInformationType", ["ByPolygonVertex"], "S", []],
                ["ReferenceInformationType", ["Direct"], "S", []],
                ["Normals", [[0.0, 0.0, 1.0, 0.0, 0.0, 1.0, 0.0, 0.0, 1.0, 0.0, 0.0, 1.0, 0.0, -1.0, 0.0, 0.0, -1.0, 0.0, 0.0, -1.0, 0.0, 0.0, -1.0, 0.0, -1.0, 0.0, 0.0, -1.0, 0.0, 0.0, -1.0, 0.0, 0.0, -1.0, 0.0, 0.0, 0.0, 0.0, -1.0, 0.0, 0.0, -1.0, 0.0, 0.0, -1.0, 0.0, 0.0, -1.0, 1.0, 0.0, 0.0, 1.0, 0.0, 0.0, 1.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 1.0, 0.0, 0.0, 1.0, 0.0, 0.0, 1.0, 0.0]], "d", []]]],
            ["LayerElementUV", [0], "I", [
                ["Version", [101], "I", []],
                ["Name", ["UVMap"], "S", []],
                ["MappingInformationType", ["ByPolygonVertex"], "S", []],
                ["ReferenceInformationType", ["IndexToDirect"], "S", []],
                ["UV", [[0.375, 0.25, 0.625, 0.25, 0.375, 0.75, 0.625, 0.5, 0.375, 0.75, 0.625, 0.75, 0.125, 0.5, 0.875, 0.5, 0.625, 0.0, 0.625, 0.75, 0.375, 0.0, 0.375, 0.5, 0.875, 0.75, 0.375, 0.5, 0.375, 0.25, 0.125, 0.75, 0.375, 1.0, 0.625, 0.25, 0.625, 0.5, 0.625, 1.0]], "d", []],
                ["UVIndex", [[10, 8, 17, 0, 14, 1, 18, 13, 13, 18, 9, 4, 4, 5, 19, 16, 6, 11, 2, 15, 3, 7, 12, 5]], "i", []]]],
            ["LayerElementMaterial", [0], "I", [
                ["Version", [101], "I", []],
                ["Name", [""], "S", []],
                ["MappingInformationType", ["ByPolygon"], "S", []],
                ["ReferenceInformationType", ["IndexToDirect"], "S", []],
                ["Materials", [[0, 1, 0, 1, 1, 0]], "i", []]]],
            ["Layer", [0], "I", [
                ["Version", [100], "I", []],
                ["LayerElement", [], "", [
                    ["Type", ["LayerElementNormal"], "S", []],
                    ["TypedIndex", [0], "I", []]]],
                ["LayerElement", [], "", [
                    ["Type", ["LayerElementUV"], "S", []],
                    ["TypedIndex", [0], "I", []]]],
                ["LayerElement", [], "", [
                    ["Type", ["LayerElementMaterial"], "S", []],
                    ["TypedIndex", [0], "I", []]]]]]]],
        ["Model", [104384422, "Cube::Model", "Mesh"], "LSS", [
            ["Version", [232], "I", []],
            ["Properties70", [], "", [
                ["P", ["Lcl Rotation", "Lcl Rotation", "", "A", -90.00000933466734, 0.0, 0.0], "SSSSDDD", []],
                ["P", ["Lcl Scaling", "Lcl Scaling", "", "A", 100.0, 100.0, 100.0], "SSSSDDD", []],
                ["P", ["DefaultAttributeIndex", "int", "Integer", "", 0], "SSSSI", []],
                ["P", ["InheritType", "enum", "", "", 1], "SSSSI", []]]],
            ["MultiLayer", [0], "I", []],
            ["MultiTake", [0], "I", []],
            ["Shading", [true], "C", []],
            ["Culling", ["CullingOff"], "S", []]]],
        ["Material", [250736289, "Troublesome Blue::Material", ""], "LSS", [
            ["Version", [102], "I", []],
            ["ShadingModel", ["Phong"], "S", []],
            ["MultiLayer", [0], "I", []],
            ["Properties70", [], "", [
                ["P", ["DiffuseColor", "Color", "", "A", 0.032999999821186066, 0.12200000137090683, 0.800000011920929], "SSSSDDD", []],
                ["P", ["EmissiveColor", "Color", "", "A", 0.032999999821186066, 0.12200000137090683, 0.800000011920929], "SSSSDDD", []],
                ["P", ["EmissiveFactor", "Number", "", "A", 0.0], "SSSSD", []],
                ["P", ["AmbientColor", "Color", "", "A", 0.05087608844041824, 0.05087608844041824, 0.05087608844041824], "SSSSDDD", []],
                ["P", ["AmbientFactor", "Number", "", "A", 0.0], "SSSSD", []],
                ["P", ["TransparentColor", "Color", "", "A", 0.032999999821186066, 0.12200000137090683, 0.800000011920929], "SSSSDDD", []],
                ["P", ["SpecularColor", "Color", "", "A", 0.032999999821186066, 0.12200000137090683, 0.800000011920929], "SSSSDDD", []],
                ["P", ["SpecularFactor", "Number", "", "A", 0.25], "SSSSD", []],
                ["P", ["Shininess", "Number", "", "A", 25.0], "SSSSD", []],
                ["P", ["ShininessExponent", "Number", "", "A", 25.0], "SSSSD", []],
                ["P", ["ReflectionColor", "Color", "", "A", 0.032999999821186066, 0.12200000137090683, 0.800000011920929], "SSSSDDD", []],
                ["P", ["ReflectionFactor", "Number", "", "A", 0.0], "SSSSD", []]]]]],
        ["Material", [408922270, "Troublesome Blue with Full Red Channel::Material", ""], "LSS", [
            ["Version", [102], "I", []],
            ["ShadingModel", ["Phong"], "S", []],
            ["MultiLayer", [0], "I", []],
            ["Properties70", [], "", [
                ["P", ["DiffuseColor", "Color", "", "A", 1.0, 0.12200000137090683, 0.800000011920929], "SSSSDDD", []],
                ["P", ["EmissiveColor", "Color", "", "A", 1.0, 0.12200000137090683, 0.800000011920929], "SSSSDDD", []],
                ["P", ["EmissiveFactor", "Number", "", "A", 0.0], "SSSSD", []],
                ["P", ["AmbientColor", "Color", "", "A", 0.05087608844041824, 0.05087608844041824, 0.05087608844041824], "SSSSDDD", []],
                ["P", ["AmbientFactor", "Number", "", "A", 0.0], "SSSSD", []],
                ["P", ["TransparentColor", "Color", "", "A", 1.0, 0.12200000137090683, 0.800000011920929], "SSSSDDD", []],
                ["P", ["SpecularColor", "Color", "", "A", 1.0, 0.12200000137090683, 0.800000011920929], "SSSSDDD", []],
                ["P", ["SpecularFactor", "Number", "", "A", 0.25], "SSSSD", []],
                ["P", ["Shininess", "Number", "", "A", 25.0], "SSSSD", []],
                ["P", ["ShininessExponent", "Number", "", "A", 25.0], "SSSSD", []],
                ["P", ["ReflectionColor", "Color", "", "A", 1.0, 0.12200000137090683, 0.800000011920929], "SSSSDDD", []],
                ["P", ["ReflectionFactor", "Number", "", "A", 0.0], "SSSSD", []]]]]]]],
    ["Connections", [], "", [
        ["C", ["OO", 104384422, 0], "SLL", []],
        ["C", ["OO", 648153506, 104384422], "SLL", []],
        ["C", ["OO", 250736289, 104384422], "SLL", []],
        ["C", ["OO", 408922270, 104384422], "SLL", []]]],
    ["Takes", [], "", [
        ["Current", [""], "S", []]]]]

The transparency seems to be equivelant to the Red value on a material in Blender, i.e. (0, 100, 100) will be a solid color, and (127,100,100) will be about 50% transparency. More details from this here: https://stackoverflow.com/a/54462858/5905035

@joao (curlicue) check the FBX JSON-inifed above, exported colors from Blender are totally valid. If unity uses colors value to generate alpha, we can’t do much…

And you link is not the right one I guess…

It looks like an issue with unity mixing up the colors values, could be an issue on Unity, or in the Blender exporter, I don't know. I've updated the comment with the right link, maybe that'll be useful to try and reproduce.

What strikes me as especially odd is that Unity treats the Maya-generated FBX properly. That makes me think that either the Blender-generated FBX has some strange non-obvious flaw or other (gee, that's helpful of me, eh? lol), or Unity's importer has some strange FBX import bug that would have to be related to differences in the structures of the documents. Given that the JSON-ified FBX seems entirely valid, I suppose it must be the latter—which is disheartening, because I don't imagine Unity has any interest in changing their .blender import mechanism until Blender v2.8 gets a non-beta/"stable" release.

Though... I think I'd heard that Unity's import process tells the source program itself to generate the FBX... which it would then probably still import improperly.

Yuck. What a mess. In any event, please don't hesitate to give a shout if there's anything I can do to help track this sucker down.

Hi, I'm a developer on the DCC team at Unity and I think I know what's going on here..
Maya and 3DsMax export the material transparency values in different ways, Max uses 'TransparencyFactor' but Maya uses 'TransparencyColor', there's also an 'Opacity' property (sometimes) which seems unreliable, it's all quite confusing and the FBX documentation doesn't help much..
Anyway, here's the logic Unity's FBX importer follows to determine the material alpha:

alpha = 1 - transparencyFactor
if (alpha ==1 || alpha==0)
alpha = 1- transparentColor.r

So if you're doing it the Maya way, I think the issue is that Blender writes the diffuse color in TransparencyColor.
I hope this helps!

@Thomas Chollet (thomasch) Thanks a bunch, fixing that stupid issue shall now be pretty easy (although that way of handling things indeed is confusing…). Will give it a try tomorrow. I knew Maya and Max had different transform systems (for objects & co) in FBX, I did not dare to have nightmares that they could do the same for other things! ;)

That's excellent! Thanks to both of you for your work investigating this irritating little pest of a bug! :D

Just pushed a tentative fix, though am rather confident about it, would be great if someone could give it a try in real-life. ;)

Bastien Montagne (mont29) lowered the priority of this task from Confirmed, Medium to Needs Information from User.May 11 2019, 3:47 PM

Just exported two FBXs from the bundle of goodies I had posted here previously, brought them into Unity, and woohoo! I haven't done extensive testing, but it sure looks to me like you kicked that problem's caboose!

Thank you so much for your work, Bastien, it is hugely appreciated. In general, too, not just on this particular issue. 😃

EDIT: Oh, and just for the sake of clarity, I exported from the "May 12, 00:06:24" build of Blender v2.8 beta.

Great, thanks for testing, we can close that one then (and for once, after actually understanding what we were expected to be doing… ;) ).

Nice to see that bug fixed! If there's other Unity import related issues in the future, don't hesitate to poke me, I can't guarantee a quick response every time but I'll sure try to help as much as I can.